'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var rxjs = require('rxjs');
var operators = require('rxjs/operators');
var observable = require('./internal/observable.js');

class Router {
  event$ = observable.getHistoryEventObservable().pipe(operators.share());

  get url() {
    return rxjs.concat(rxjs.of(window.location.href), this.event$).pipe(operators.distinctUntilChanged());
  }

  get urlChange() {
    return this.event$.pipe(operators.distinctUntilChanged());
  }

}

exports.Router = Router;
//# sourceMappingURL=router.js.map
