'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var constants = require('../constants.js');
var util = require('./util.js');

const toSocketIoMessagePayload = (id, data) => {
  return `${constants.packetTypes.send}${id}${JSON.stringify(['socket.io-request', data])}`;
};
const isConnectionMessage = message => {
  return message[0] === constants.packetTypes.initialize;
};
const isResponseOf = expected => ({
  sid
}) => expected === sid; // 430[{...}}] => 430, [{}]
// @see https://github.com/socketio/engine.io-protocol

const scrapboxDeserializer = event => {
  let packetType = '';
  let message = String(event.data);

  while (message.length) {
    const head = message[0];

    if (util.isIntegerString(head)) {
      packetType += head;
      message = message.substr(1);
    } else {
      return [packetType, JSON.parse(message)];
    }
  }

  return [packetType, undefined];
};
const scrapboxSerializer = message => {
  return typeof message === 'string' ? message : JSON.stringify(message);
};

exports.isConnectionMessage = isConnectionMessage;
exports.isResponseOf = isResponseOf;
exports.scrapboxDeserializer = scrapboxDeserializer;
exports.scrapboxSerializer = scrapboxSerializer;
exports.toSocketIoMessagePayload = toSocketIoMessagePayload;
//# sourceMappingURL=message.js.map
