import { concat, of } from 'rxjs';
import { share, distinctUntilChanged } from 'rxjs/operators';
import { getHistoryEventObservable } from './internal/observable.js';

class Router {
    event$ = getHistoryEventObservable().pipe(share());
    get url() {
        return concat(of(window.location.href), this.event$).pipe(distinctUntilChanged());
    }
    get urlChange() {
        return this.event$.pipe(distinctUntilChanged());
    }
}

export { Router };
//# sourceMappingURL=router.js.map
