import { Observable } from 'rxjs';
import type NodeWebSocket from 'ws';
export interface MessageDeserializer<T = MessageEvent | NodeWebSocket.MessageEvent, U = any> {
    (event: T): U;
}
export interface MessageSerializer<T = any, U = any> {
    (event: T): U;
}
export declare class RxWebSocket {
    private readonly websocket;
    private readonly opened$;
    private readonly events$;
    private readonly serializer;
    private readonly deserializer;
    constructor({ url, protocols, options, serializer, deserializer, }: {
        url: string;
        protocols?: string | string[];
        options?: NodeWebSocket.ClientOptions;
        serializer: MessageSerializer;
        deserializer: MessageDeserializer;
    });
    get active(): boolean;
    get message(): Observable<any>;
    send(message: string): Observable<any>;
}
